using Syncfusion.Windows.Forms.Grid.Grouping;

namespace CommonUI
{
	/// <summary>
	/// Summary description for GridStyleFormatter.
	/// </summary>
	public class GridStyleFormatter
	{
		private readonly GridTableCellStyleInfo[] cellStyles;

		/// <summary>
		/// There's an array of GridTableCellStyleInfo items because some sections of the grid
		/// need more than one style that's applicable
		/// </summary>
		public GridStyleFormatter(GridTableCellStyleInfo[] cellStyles) {
			//DBC.CheckPre("cellStyles cannot be null", cellStyles != null);

			this.cellStyles = cellStyles;
		}

		/// <summary>
		/// Copies a style to the relevant StyleInfos
		/// </summary>
		public void ApplyStyle(GridTableCellStyleInfo newStyle) {
			foreach(GridTableCellStyleInfo style in cellStyles) {
				style.CopyFrom(newStyle);
			}
		}
	}
}
