using System;
using CommonUI.Common.Collections; 

namespace CommonUI
{
	/// <summary>
	/// Summary description for MergedColumnHeaderCollection.
	/// </summary>
	public class MergedColumnHeaderCollection : ObjectSequence
	{
		
		public new MergedColumnHeader this[int index] {
			get { return (MergedColumnHeader)base[index]; }
		}

		
		public void Add(MergedColumnHeader mergedColumnHeader) {
			//DBC.CheckPre("mergedColumnHeader must not be null", mergedColumnHeader != null);
			base.AddElement(mergedColumnHeader);
		}

		public void AddRange(MergedColumnHeader[] mergedColumnHeaders) {
			//DBC.CheckPre("mergedColumnHeaders cannot be null", mergedColumnHeaders != null);
			base.AddRange(mergedColumnHeaders);
		}

		public MergedColumnHeader FindWithMappingName(string mappingName) {
			MergedColumnHeader foundHeader = null;

			foreach(MergedColumnHeader colHeader in this) {
				if (colHeader.GridColumn1.MappingName == mappingName
					||
					colHeader.GridColumn2.MappingName == mappingName) {
					foundHeader = colHeader;
					break;
				}
			}

			return foundHeader;
		}
	}
}
