using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Grouping;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace Main
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{		
		private DataTable table;

		int randomKey = 100;
		int zipCount = 100;
		int recordCount = 20000;		
		string[] states = new string[]{"North Carolina", "South Carolina", "Washington", "Nevada", "Ohio"};
		private ProjectControls.ViewGridControl viewGridControl1;
		private System.Windows.Forms.CheckBox chkBatch;
		private System.Windows.Forms.Button btnUpdate;
		private System.Windows.Forms.Button btnCancel;
		
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			InitializeComponent();	
			this.viewGridControl1.RefreshView +=new ProjectControls.ViewGridControl.DelegateMethodNoArgs(viewGridControl1_RefreshView); 
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.viewGridControl1 = new ProjectControls.ViewGridControl();
			this.chkBatch = new System.Windows.Forms.CheckBox();
			this.btnUpdate = new System.Windows.Forms.Button();
			this.btnCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// viewGridControl1
			// 
			this.viewGridControl1.AutoScroll = true;
			this.viewGridControl1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.viewGridControl1.Location = new System.Drawing.Point(16, 16);
			this.viewGridControl1.Name = "viewGridControl1";
			this.viewGridControl1.ShowFullGroupingText = false;
			this.viewGridControl1.Size = new System.Drawing.Size(856, 448);
			this.viewGridControl1.TabIndex = 0;
			//this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableModel.Options.ActivateCurrentCellBehavior = GridCellActivateAction.None;

			// 
			// chkBatch
			// 
			this.chkBatch.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.chkBatch.Checked = true;
			this.chkBatch.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkBatch.Location = new System.Drawing.Point(16, 488);
			this.chkBatch.Name = "chkBatch";
			this.chkBatch.Size = new System.Drawing.Size(104, 16);
			this.chkBatch.TabIndex = 10;
			this.chkBatch.Text = "Real-time";
			// 
			// btnUpdate
			// 
			this.btnUpdate.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnUpdate.Location = new System.Drawing.Point(360, 480);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.Size = new System.Drawing.Size(75, 24);
			this.btnUpdate.TabIndex = 9;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// btnCancel
			// 
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(448, 480);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(75, 24);
			this.btnCancel.TabIndex = 11;
			this.btnCancel.Text = "Close";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(888, 525);
			this.Controls.Add(this.chkBatch);
			this.Controls.Add(this.btnUpdate);
			this.Controls.Add(this.btnCancel);
			this.Controls.Add(this.viewGridControl1);
			this.Name = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load_1);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		

		private void Form1_Load_1(object sender, System.EventArgs e) {
			Random random = new Random(randomKey++);
			int numStates = states.GetLength(0);
			string nameFormat = "Name{0:00000}";

			this.table = new DataTable("Test");
						
			DataColumn col = table.Columns.Add();
			col.DataType = typeof(bool);
			col.ColumnName = "Selected";
			
			col = table.Columns.Add();
			col.DataType = typeof(string);
			col.ColumnName = "Img";
			
			col = table.Columns.Add();
			col.DataType = typeof(string);
			col.ColumnName = "EditedImage";

			col = table.Columns.Add();
			col.DataType = typeof(int);
			col.ColumnName = "Id";

			col = table.Columns.Add();
			col.DataType = typeof(string);
			col.ColumnName = "Name";

			col = table.Columns.Add();
			col.DataType = typeof(string);
			col.ColumnName = "State";

			col = table.Columns.Add();
			col.DataType = typeof(int);
			col.ColumnName = "Zip";
		
			
			for(int i = 7; i < 14; i++){
				this.table.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));
			}
			
			col = table.Columns.Add();
			col.DataType = typeof(DateTime);
			col.ColumnName = "Date";

			this.table.PrimaryKey = new DataColumn[1] {this.table.Columns["Id"]};
						
			for(int i = 2; i < recordCount; i++) {
				DataRow row = this.table.NewRow();
				row["Id"] =  i;
				row["Name"] = string.Format(nameFormat, i);
				row["State"] = states[random.Next(numStates-1)];
				row["Zip"] = random.Next(zipCount);
				row["Col7"]= i + 5;
				row["Col8"]= i + 6;
				row["Col9"]= i + 7;
				row["Col10"]= i + 8;
				row["Col11"]= i + 9;
				row["Col12"]= i + 10;
				row["Col13"]= i + 11;
				row["Date"] = System.DateTime.Now.Date.AddDays(i);
				this.table.Rows.Add(row);
			}
			
			this.table.AcceptChanges();
			this.table.DefaultView.RowStateFilter = DataViewRowState.CurrentRows;
			this.viewGridControl1.GroupingGrid.DataSource = this.table;
			
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.CellType = "Image";
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[1].HeaderText = "   ";
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[1].Width = 20;	
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.CellType = "Image";
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[2].HeaderText = "   ";
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[2].Width = 20;	
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[3].Width = 25;	
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[14].Width = 80;	
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[0].Width = 20;	
			this.viewGridControl1.GroupingGrid.SyncfusionGridControl.TableDescriptor.Columns[0].HeaderText = " ";
		
		}

		private void viewGridControl1_RefreshView() {			
			if (this.chkBatch.Checked) {						
				// RefreshviewDetails is called from within the BindingList.ListChanged event handler. That is it is called
				// while the DefaultView and DataTable have not finished all their changes and the ListChanged has not been handled yet
				// by attached CurrencyManagers and therefore they are still in pending state.
				// RefreshView calls AcceptChanges and queries the row count of the list which then results in the CurrencyManager view
				// getting out of sync.
				//
				// If we delay these calls until after ListChanged event returned control to the DataView and the CurrencyManager
				// also had a chance to handle the ListChanged event it is fine to access the DataView again and also call DataTable.AcceptChanges.
				Timer t = new Timer();
				t.Tick += new EventHandler(t_Tick);
				t.Interval = 10;
				t.Start();	
			    
			}
		}

		private void t_Tick(object sender, EventArgs e) {
			Timer t = (Timer) sender;
			t.Tick -= new EventHandler(t_Tick);
			t.Dispose();
			CommonUpdateCode();                             
		}

		private void CommonUpdateCode() {
			DataTable changes = this.table.GetChanges();
			if(changes != null) {
				Console.WriteLine("CommonUpdateCode: {0} changed rows", changes.Rows.Count);	
				//Record r = this.viewGridControl1.GroupingGrid.SyncfusionGridControl.Table.CurrentRecord;
				this.viewGridControl1.IgnoreReset = true;
				this.table.AcceptChanges();
				//this.viewGridControl1.GroupingGrid.SyncfusionGridControl.Table.CurrentRecord = r;				
			}
			changes = null;
		}

		private void btnUpdate_Click(object sender, System.EventArgs e) {
			CommonUpdateCode();
		}
	}
}
